# $Id: browser.tcl 700 2006-08-17 16:11:55Z sergei $

namespace eval search {}

namespace eval search::browser {
    hook::add open_browser_post_hook [namespace current]::setup_panel
    hook::add open_disco_post_hook [namespace current]::setup_panel
}

proc search::browser::open_panel {w sw sf} {
    set sentry $sf.search
	
    pack $sf -side bottom -anchor w -fill x -before $sw
    focus $sentry
}

proc search::browser::close_panel {sf tw} {
    pack forget $sf
    focus $tw
}

proc search::browser::setup_panel {w sw tw} {
    set sf [frame $w.search]

    set sentry \
	[entry $sf.search \
	       -validate all \
	       -validatecommand [list [namespace parent]::validate_entry %W %P]]
    pack $sentry -padx 1m -side left

    set sbox [ButtonBox $sf.sbox -spacing 0]
    $sbox add -text [::msgcat::mc "Search up"] \
         -command [list [namespace parent]::bwtree::do_search $tw $sentry 1]
    $sbox add -text [::msgcat::mc "Search down"] \
         -command [list [namespace parent]::bwtree::do_search $tw $sentry 0]
    pack $sbox -side left -padx 1m
    
    set cbox [ButtonBox $sf.cbox -spacing 0]
    $cbox add -text [::msgcat::mc "Close"] \
         -command [list [namespace current]::close_panel $sf $tw]
    pack $cbox -side right -padx 1m

    bind $sentry <Key-Return> [double% [list $sbox invoke 0]]
    bind $sentry <Shift-Key-Return> [double% [list $sbox invoke 1]]
    bind $sentry <Escape> \
	[double% [list [namespace current]::close_panel $sf $tw]]

    bind $tw.c <<OpenSearchPanel>> \
	[double% [list [namespace current]::open_panel $w $sw $sf]]
}

