# $Id: logger.tcl 700 2006-08-17 16:11:55Z sergei $

namespace eval search {}

namespace eval search::logger {
    hook::add open_log_post_hook [namespace current]::setup_panel
}

proc search::logger::open_panel {sf w tw} {
    set sentry $sf.search

    pack $sf -side bottom -anchor w -fill x -before $w.sw
    focus $sentry

    update idletasks
    $tw see end
}

proc search::logger::close_panel {sf tw} {
    $tw tag remove search_highlight 0.0 end
    pack forget $sf
}

proc search::logger::setup_panel {connid jid w} {
    set tw $w.sw.log

    $tw mark set sel_start end
    $tw mark set sel_end 0.0

    set sf [frame $w.search]

    set sentry \
	[entry $sf.search \
	       -validate all \
	       -validatecommand [list [namespace parent]::validate_entry %W %P]]
    pack $sentry -padx 1m -side left

    set sbox [ButtonBox $sf.sbox -spacing 0]
    $sbox add -text [::msgcat::mc "Search up"] \
         -command [list [namespace parent]::do_text_search $tw $sentry 1]
    $sbox add -text [::msgcat::mc "Search down"] \
         -command [list [namespace parent]::do_text_search $tw $sentry 0]
    pack $sbox -side left -padx 1m
    
    set cbox [ButtonBox $sf.cbox -spacing 0]
    $cbox add -text [::msgcat::mc "Close"] \
         -command [list [namespace current]::close_panel $sf $tw]
    pack $cbox -side right -padx 1m

    bind $sentry <Key-Return> [double% [list $sbox invoke 0]]
    bind $sentry <Shift-Key-Return> [double% [list $sbox invoke 1]]
    bind $sentry <Escape> \
	[double% [list [namespace current]::close_panel $sf $tw]]

    bind $w <<OpenSearchPanel>> \
	[double% [list [namespace current]::open_panel $sf $w $tw]]
}

